import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrUserdotmatrixpen {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  UserId!: IType<number, bigint>;
  PenId!: IType<number, bigint>;
  PenSerialNo?: string;
  PenType!: number;
  UserType!: number;
  Remark?: string;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrUserdotmatrixpenSchema = defineEntity({
  class: IcrUserdotmatrixpen,
  comment: '学生和点阵笔的关系',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    UserId: p.bigint().name('UserId').columnType('bigint').comment('用户Id'),
    PenId: p.bigint().name('PenId').columnType('bigint').comment('笔Id'),
    PenSerialNo: p.string().name('PenSerialNo').nullable().comment('笔序列号'),
    PenType: p.integer().name('PenType').comment('笔用途类型;1. 写 2. 修改'),
    UserType: p.integer().name('UserType').comment('用户类型;1 学生 2 教师'),
    Remark: p.string().name('Remark').nullable().comment('备注'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
